<?php
// File           script_start.inc.php
// Purpose        includes and initialisations needed in every main script
// Author         Lutz Brueckner <irie@gmx.de>
// Copyright      (c) 2000, 2001, 2002, 2003, 2004, 2005 by Lutz Brueckner,
//                published under the terms of the GNU General Public Licence v.2,
//                see file LICENCE for details
// Created        <00/10/18 09:22:43 lb>
//
// $Id: script_start.inc.php,v 1.26.2.6 2005/10/10 09:03:30 lbrueckner Exp $

//apd_set_pprof_trace();

require('./inc/configuration.inc.php');

session_start();

if (DEBUG) $start_time = @microtime();

require('./lang/' . configured_language() . '.inc.php');
require('./inc/session.inc.php');
require('./inc/functions.inc.php');
require('./inc/array_functions.inc.php');
require('./inc/interbase.inc.php');
require('./inc/panel_elements.inc.php');
require('./inc/javascript.inc.php');

if (DEBUG  ||  DEBUG_HTML) {
    include('./inc/debug_funcs.inc.php');
}

set_error_handler('error_handler');

ini_set('magic_quotes_runtime', '0');
ini_set('zend.ze1_compatibility_mode', '0');

if (!in_array('interbase', get_loaded_extensions())) {
    @dl('interbase.so')  ||  @dl('interbase.dll');
}

send_http_headers();

if (!isset($HTTP_SESSION_VARS['s_init'])
||  ($HTTP_SESSION_VARS['s_cookies'] === 'untested')) {
    if (!in_array('interbase', get_loaded_extensions())) {

        die($ERRORS['NO_IBASE_MODULE']);
    }

    $ver = phpversion();
    if ($ver[0] == 5  &&
        ini_get('register_long_arrays') == 0) {

        die('You have to change your php-configuration and set register_long_arrays=On to use ibWebAdmin with php5!');
    }
    initialize_session();
    fallback_session();
}
else {
    localize_session_vars();
}

if (!isset($no_session_referer)  ||  $no_session_referer !== TRUE) {
    // save referer in the session, $_SERVER['HTTP_REFERER'] is not always set
    $s_referer = !empty($_SERVER['PHP_SELF']) ? $_SERVER['PHP_SELF'] : $_SERVER['SCRIPT_NAME'];
}


// warnings and messages are collected in this strings, the output happens in panels/info.php
$message   = '';
$warning   = '';
$error     = '';
$ib_error  = '';
$php_error = '';
$debug     = array();
$externcmd = '';


// this string is filled in the panels and echoed in script_end.inc.php
// to avoid problems ns4.7 has with javascript inside of tables
$js_stack = '';

// the different tasks storing their sql-statements in this string
// for joint execution just before the panel-output
$sql =  '';


// connecting the database, the handle is used as a global variable,
// the connection is closed in inc/script_end.inc.php
if ($s_connected == TRUE  &&  !isset($HTTP_GET_VARS['unconnected'])) {

    $dbhandle = db_connect();

    if ($dbhandle === FALSE) {
        $ib_error = ibase_errmsg();
        $s_connected = FALSE;
        $s_tables_valid = FALSE;
        $s_watch_table = '';
    }

    if (empty($s_charsets)) {
        $s_charsets = get_charsets();
    }
}

// determine server family and version
list($family, $version) = server_info($s_login['server']);
define('SERVER_FAMILY', $family);
define('SERVER_VERSION', $version);


// set the path to the navigation icons used on the panels
$icon_path = DATAPATH . (BG_TRANSPARENT == TRUE ? 'transparent/' : 'opaque/') . strtolower(ICON_SIZE) . '/';
$open_icon  = $icon_path.'open.png';
$close_icon = $icon_path.'close.png';
$red_triangle_icon   = $icon_path.'red_triangle.png';
$green_triangle_icon = $icon_path.'green_triangle.png';


if ($s_binpath != BINPATH) {
    // check the availabillity of the isql binary
    if (!is_dir(BINPATH)
    ||  (!is_file(BINPATH.'isql')  &&  !is_file(BINPATH.'isql.exe'))) {

        $warning = sprintf($WARNINGS['BAD_ISQLPATH'], BINPATH);
    }

    // check if TMPPATH is an existing, writeable directory
    if (!is_dir(TMPPATH)  ||  !is_writeable(TMPPATH)) {

        $warning .= sprintf($WARNINGS['BAD_TMPPATH'], TMPPATH);
    }

    $s_binpath = BINPATH;
}

if (DEBUG_HTML) ob_start();



function configured_language() {
    global $HTTP_SESSION_VARS;
    
    $language = isset($HTTP_SESSION_VARS['s_cust']['language'])  &&  !empty($HTTP_SESSION_VARS['s_cust']['language'])
              ? $HTTP_SESSION_VARS['s_cust']['language']
              : LANGUAGE;

    return $language;
}

?>
